import java.util.ArrayList;

public class Algtegurid {

    // Eratosthenese sel
    static int SP = 1000000; // sela pikkus
    static char[] soel = new char[SP]; // algarvude jada

    static void alg() {
        int i, j;
        for (i = 0; i < SP; i++)
            soel[i] = 1; // alguses paneme kik algarvudeks
        soel[0] = 0; // 0 ei ole algarv
        soel[1] = 0; // 1 ei ole algarv
        for (i = 2; i * i <= SP; i++) {
            if (soel[i] == 1)
                for (j = i * i; j < SP; j += i)
                    soel[j] = 0;
        }
    }

// Arvu algtegurite leidmine
    static ArrayList<Long> algtegurid(long n){
        ArrayList<Long> tegurid = new ArrayList<>(); // siin hoiame vastust
        int aa = 1; // jrgmine algarv, millega jagame
        while (++aa < SP){ // otsime selast
            if (soel[aa] == 0) continue; // kui ei ole algarv, vtame jrgmise
            if (aa*aa > n) break; // kui teguri ruut on suurem kui n, siis lpetame
            while (n % aa == 0) { // kuni jagub vaadeldava algarvuga
                tegurid.add((long) aa); // kirjutame selle algarvu tegurite massiivi
                n /= aa; // jagame n-i lbi
            }
        }
        if (n != 1) tegurid.add(n); // kui meil midagi jrele ji, siis ehk algarv
        return tegurid;
    }

    public static void main(String[] args) {
        alg(); // tidab sela

        ArrayList<Long> r = algtegurid(2147483647);
        int i;
        for (i = 0; i < r.size(); i++) {
            System.out.print(r.get(i) + " ");
        }
        System.out.println();

        r = algtegurid(136117223861L);
        for (i = 0; i < r.size(); i++) {
            System.out.print(r.get(i) + " ");
        }
        System.out.println();

        r = algtegurid(142391208960L);
        for (i = 0; i < r.size(); i++) {
            System.out.print(r.get(i) + " ");
        }
        System.out.println();
    }
}