import java.util.Scanner;

public class Arvusysteemid {

    static double EPS = 1e-20;
    static double min_jaak;
    static double max_jaak;
    static double vaartus;
    static String vastus;

    //leiab leitavast kohast lejva osa lubatava maksimaalse ja minimaalse vrtuse
    static void leiaJaagid(double astendatudalus, double min_kordaja, double max_kordaja)
    {
        if (!(astendatudalus < 0L)){
            min_jaak = astendatudalus*min_kordaja - EPS;
            max_jaak = astendatudalus*max_kordaja + EPS;
        }
        else{ // negatiivsel alusel kui on paarituarvuline aste, siis max ja min on vahetuses
            min_jaak = astendatudalus*max_kordaja - EPS;
            max_jaak = astendatudalus*min_kordaja + EPS;
        }
    }

    //Leiab "jrgmise" numbri ehk esimese numbri jrelejnud teisendatavast osast
    static char leiaNumber(double astendatudalus, int numbrite_arv, double min_kordaja, double max_kordaja)
    {
        char number;
        double kontroll = vaartus;
        boolean leitud = false;
        double jrgm_min_jaak, jrgm_max_jaak;
        leiaJaagid(astendatudalus, min_kordaja, max_kordaja);

        // proovime, milline saaks olla jrgmine leitav number
        for (number = 0; number < numbrite_arv; ++number) {
            if (kontroll > min_jaak && kontroll < max_jaak) {
                leitud = true;
                vaartus = kontroll; // vrtus saab vrdseks teisendamata osaga
                break;
            }
            // eelmine number ei sobinud, suurema numbri proovimisel vhendame jki
            kontroll = kontroll - astendatudalus;
        }
        return (char)('0' + number);
    }

    //keerab stringi mber ja nihutab koma igesse kohta
    static void keera()
    {
        if (vastus.indexOf('.') == -1) { // ja tulemuses koma ei ole
            vastus = vastus + ".0"; // lisame ".0" vastuse lppu
        }
        int koma_asukoht = vastus.indexOf('.');
        // nihutame koma stringis vasakule, sest see kuulub selle arvu juurde, mille jrel ta on nt 123. on tegelikult 1 2 ja 3., keerates tahame saada 3.21
        StringBuilder tmp = new StringBuilder(vastus.substring(0, koma_asukoht - 1) + vastus.charAt(koma_asukoht) + vastus.charAt(koma_asukoht-1) + vastus.substring(koma_asukoht + 1));
        tmp.reverse(); // ja keerame vastuse mber
        vastus = tmp.toString();
    }

    // eemaldab nullid arvu eest ja lpust, vajadusel eemaldab ka koma lpust.
    static void normaliseeri()
    {

        while (vastus.charAt(vastus.length()-1) == '0'){ // eemaldame nullid murdosa lpust
            vastus = vastus.substring(0, vastus.length()-1);
        }
        if (vastus.charAt(vastus.length()-1) == '.'){ // eemaldame koma (tis)arvu lpust
            vastus = vastus.substring(0, vastus.length()-1);
        }
        // eemaldame nullid algusest
        while (vastus.length() >= 2 && vastus.charAt(0) == '0' && vastus.charAt(1) != '.'){
            vastus = vastus.substring(1);
        }
    }

    static String teisenda(double alus)
    {
        vastus = "";
        int numbrite_arv = 0; //ssteemis kasutatavate numbrite ehk mrkide arv
        double astendatudalus = 1L; //aluse aste, mida ttleme
        double p_alus = 1L / alus; // aluse prdvrtus
        boolean alus_vahetatud = false;
        if (Math.abs(p_alus) > Math.abs(alus)){
            p_alus = alus;
            alus = 1L / alus;
            alus_vahetatud = true;
        }

        while ((double) numbrite_arv < Math.abs(alus) - EPS){
            ++numbrite_arv; // suurendame, kuni on vhemalt aluse absoluutvtusega vrdne
        }

        int ennekoma = 0; // kohtade arv enne koma uues ssteemis
        while (!(vaartus < astendatudalus)){
            astendatudalus *= alus;
            ++ennekoma;
        }

        double min_kordaja = 0L;
        double max_kordaja = 0L;
        if (p_alus > 0L){ // kui alus on positiivne
            max_kordaja = (double)(numbrite_arv - 1) / (alus - 1);
        }
        else{
            min_kordaja = (double)(numbrite_arv - 1)*p_alus / (1L - p_alus*p_alus);
            max_kordaja = min_kordaja / alus;
        }

        while (vastus.length() < 990 && Math.abs(vaartus) > EPS*(double)(10L)) {
            vastus +=
                    leiaNumber(astendatudalus, numbrite_arv, min_kordaja, max_kordaja);
            astendatudalus /= alus;
            if (ennekoma == 0) vastus += '.';
            --ennekoma;
        }

        if (alus_vahetatud)  // kui alus oli 0 ja 1 vahel
            keera();
        normaliseeri();

        return vastus;
    }


    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        vaartus = scanner.nextDouble(); //teisendatava arvu vrtus
        double alus = scanner.nextDouble(); //alus, kuhu teisendatakse
        System.out.println(teisenda(alus));

    }
}
